package HomeMade.Tracking;
import ij.IJ;
import java.util.Arrays;
import java.util.List;
import java.lang.Math;
import java.util.ArrayList;
import HomeMade.Tracking.*;

import ij.*;
public class FociTrackingMulti {
	public static void trackmyFoci(data Data){
		double[] area = Data.area;
		double[] x_coord = Data.x;
		double[] y_coord = Data.y;
		double[] frame = Data.frame;
		String ColorSet=Data.ColorSet;
		ImagePlus imp =Data.imp;
		double x_coordmax = 0;
		double y_coordmax = 0;
		for (int i=0; i<x_coord.length; i++){
			if (x_coord[i]>x_coordmax){
				x_coordmax=x_coord[i];
			}
			if (y_coord[i]>y_coordmax){
				y_coordmax=y_coord[i];
			}
		}
		double areasum = 0;
		for (int i=0; i<area.length; i++){
			areasum = areasum + area[i];
		}
		double two_foci = 1.5*areasum/area.length;
		double three_foci = 1.5*two_foci;
		double L=Math.ceil(Math.max(x_coordmax,y_coordmax));
		int delx = (int)L;
		int dely = (int)L;
		double dx = L/delx;
		double dy = L/dely;
		int startiter = (int) frame[1];
		int enditer = (int) frame[frame.length-1];
		int rangesize = Data.trackRange;;
		int objnum = 0;
		ObjectArray OA = new ObjectArray(enditer);
		space s = new space(delx,dely);
		OAindices OAi = new OAindices(enditer);
		Integer[] indicestrial = new Integer[0];
		int counter = 0;
		// Create the first space
		while(frame[objnum] == startiter){
			//int fr = (int)frame[objnum];
			int ii = (int)Math.floor(x_coord[objnum]/dx);
			int jj = (int)Math.floor(y_coord[objnum]/dy);
			FociObject Foci = new FociObject(objnum+1, x_coord[objnum], y_coord[objnum], frame[objnum]);
			s.addtospace(ii, jj, Foci);
			//System.out.print(Foci.x_coord);
			OA.add(startiter-1, Foci);
			OAi.add(startiter-1, Foci.FOindex);
			System.out.print(OA.getreal(startiter-1, OA.size(startiter-1)-1).x_coord);
			System.out.print(" ");
			System.out.print(OAi.getreal(startiter-1,OAi.size(startiter-1)-1));
			System.out.print("\n");
			objnum++;
			indicestrial = OAi.find(0, Foci.FOindex);
			System.out.print(indicestrial[0]);
			System.out.print("\n");
			counter++;
		}
		// Resize OA
		OA.resize(startiter-1);
		System.out.print(OA.size(OA.sizeofOA-1));
		System.out.print("\n");
		OAi.resize(startiter-1);
		// Add these objects to the correct frame (startiter-1)
		// ObjectArray.set(startiter-1, Object);
		for (int iter=startiter+1; iter<=enditer; iter++){
			System.out.print("iter");
			System.out.print(iter);
			System.out.print(" ");
			//int istart=objnum;
			List<FociObject> toaddtospace = new ArrayList<FociObject>(0);
			while (frame[objnum]==iter){
				FociObject CurrentFoci = new FociObject(objnum+1, x_coord[objnum], y_coord[objnum], frame[objnum]);
				int ii = (int)Math.floor(x_coord[objnum]/dx);
				int jj = (int)Math.floor(y_coord[objnum]/dy);
				CurrentFoci.setcoords(ii,jj);
				toaddtospace.add(CurrentFoci);
				System.out.print("To add: ");
				System.out.print(toaddtospace.get(toaddtospace.size()-1).FOindex);
				System.out.print(" ");
				int neighbour = 0;
				int firsttry = 1;
				int spaceindex = 1;
				int range = 1;
				DistanceVector[] dist;
				dist = new DistanceVector[10];
				//double[] distvalues;
				//distvalues = new double[10];
				int distsize = 0;
				ArrayList<Neighbour> distancelist = new ArrayList<Neighbour>();
				while (neighbour==0){
					if(firsttry<=rangesize){
						range = firsttry;
						spaceindex = 1;
					}else{
						if((firsttry>rangesize)&&(spaceindex<(iter-1))&&(spaceindex<3)){
							range = (firsttry % rangesize);
							if (range ==0){
								range=rangesize;
							}
							spaceindex = (int)Math.floor((firsttry-1)/rangesize);
						}else{
							//neighbour = 1;
							break;
						}
					}
					for (int aa=(ii-range);aa<=(ii+range);aa++){
						for (int bb=(jj-range);bb<=(jj+range);bb++){
							if (aa >= 0 && bb >= 0 && aa < delx && bb < dely){
								ArrayList<FociObject> xlist = s.get(aa, bb);
								int xx = xlist.size();
								for (int qq=0;qq<xx;qq++){
									FociObject F = xlist.get(qq);
									//int obj_num = space[iter-spaceindex-1][aa][bb][xx].FOindex;
									double del_x = (x_coord[objnum]-F.x_coord);
									double del_y = (y_coord[objnum]-F.y_coord);
									double distance = Math.sqrt((del_x*del_x)+(del_y*del_y));
									Neighbour N = new Neighbour(F,distance);
									distancelist.add(N);
									//Map<Integer, Double> dist1 = new HashMap<Integer, Double>();
									//dist1.keySet<(int)F.FOindex> (double)distance;
									//dist[dist.length] = new DistanceVector(iter-spaceindex, obj_num, distance);
									//distvalues[distvalues.length] = distance;
									//distsize++;
									neighbour=1;
								}
							}
						}
					}
					firsttry++;
					//System.out.print(firsttry);
					//System.out.print(" ");
				}
				//objnum++;
				if (neighbour==1){ // There is a match!
					//Arrays.sort(distvalues);
					Arrays.sort(distancelist.toArray());
					distsize = distancelist.size();
					//DistanceVector[] newdist;
					//newdist = new DistanceVector[dist.length];
					// Sort the dist array and create newdist
					//for(int k=0;k<distvalues.length;k++){
					//	for (int j=0;j<dist.length;j++){
					//		if (dist[j].distance == distvalues[k]){
					//			newdist[k]=dist[j];
					//		}
					//	}
					//}
					FociObject[] posobj = new FociObject[0];

					if (distsize>1){
						if (area[objnum]<two_foci){
							posobj = new FociObject[1];
							posobj[0] = (distancelist.get(0)).getF();
						} else {
							if ((area[objnum]<three_foci) && (dist.length>1)) {
								posobj = new FociObject[2];
								posobj[0] = (distancelist.get(0)).getF();
								posobj[1] = (distancelist.get(1)).getF();
							} else { if (dist.length>2 && distsize>2) {
								posobj = new FociObject[3];
								posobj[0] = (distancelist.get(0)).getF();
								posobj[1] = (distancelist.get(1)).getF();
								posobj[2] = (distancelist.get(2)).getF();
							}
						}
					}
				} else {
					posobj = new FociObject[1];
					posobj[0] = (distancelist.get(0)).getF();
				 }
					//int[] index;
					//index = new int[10];
					//Integer[] indices = new Integer[0];
					Integer[] indicesOAi = new Integer[0];
					// Track all the objects
					for (int m=0;m<posobj.length;m++){
						//indices = OA.find(iter-spaceindex-1, posobj[m]);
						indicesOAi = OAi.find(iter-spaceindex-1, posobj[m].FOindex);
						if (indicesOAi.length>0){
							if (indicesOAi.length == 1){ // this happens if this is only one object
							    //if (!OA.get(iter-1, indices[0])){
								  if (!OAi.get(iter-1,indicesOAi[0])){
									  OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
									  OA.set(iter-1,indicesOAi[0],CurrentFoci);
								} else {
									if (spaceindex == 1){
										double x_cur = OA.getreal(iter-1,indicesOAi[0]).x_coord;
										double y_cur = OA.getreal(iter-1,indicesOAi[0]).y_coord;
										double x_1 = OA.getreal(iter-spaceindex-1,indicesOAi[0]).x_coord;
										double y_1 = OA.getreal(iter-spaceindex-1,indicesOAi[0]).y_coord;
										double del_xold = ((x_cur-x_1)*(x_cur-x_1));
										double del_yold = ((y_cur-y_1)*(y_cur-y_1));
										double dist_old = Math.sqrt(del_xold + del_yold);
										if (distancelist.get(m).getdist() < dist_old){
											// Place current values in new position
											OA.add(iter-1,OA.getreal(iter-1,indicesOAi[0]));
											OA.set(iter-1, indicesOAi[0], CurrentFoci);
											OAi.add(iter-1, OA.getreal(iter-1, indicesOAi[0]).FOindex);
											OAi.set(iter-1, indicesOAi[0], CurrentFoci.FOindex);
										} else {
											OA.add(iter-1,CurrentFoci);
											OAi.add(iter-1,CurrentFoci.FOindex);
										}
									} else {
										OA.add(iter-1,CurrentFoci);
										OAi.add(iter-1, CurrentFoci.FOindex);
										}
								}
								// this part is now disabled as it causes crashes on large cells
							} else { // Multiple instances to check, meaning the object is so big it likely contains multiple foci
								double theta[];
								theta = new double[2];
								for (int kk=0;kk<indicesOAi.length;kk++){
									double x_now = OA.getreal(iter-spaceindex-1,indicesOAi[kk]).x_coord;
									double y_now = OA.getreal(iter-spaceindex-1,indicesOAi[kk]).y_coord;
									double x_prev = OA.getreal(iter-(spaceindex+1)-1,indicesOAi[kk]).x_coord;
									double y_prev = OA.getreal(iter-(spaceindex+1)-1,indicesOAi[kk]).y_coord;
									double vector1 = Math.sqrt(((x_coord[objnum]-x_now)*(x_coord[objnum]-x_now))+((y_coord[objnum]-y_now)*(y_coord[objnum]-y_now)));
									double vector2 = Math.sqrt(((x_coord[objnum]-x_prev)*(x_coord[objnum]-x_prev))+((y_coord[objnum]-y_prev)*(y_coord[objnum]-y_prev)));
									double dot = ((x_now-x_coord[objnum])*(x_prev-x_coord[objnum]))+((y_now-y_coord[objnum])*(y_prev-y_coord[objnum]));
									theta[kk] = Math.acos(dot/(vector1*vector2));
									theta[kk] = Math.abs(theta[kk]-Math.PI/2);
								}
								double[] thetaori = theta;
								Arrays.sort(theta);
								// Find index
								for (int sorter=0;sorter<theta.length;sorter++){
									if (thetaori[sorter] == theta[0]){
										OA.set(iter-1, indicesOAi[sorter], CurrentFoci);
										OAi.set(iter-1, indicesOAi[sorter], CurrentFoci.FOindex);
									}
								}
							}
						} else {
							//System.out.print(iter-1);
							//System.out.print(OA.size(iter-1));
							OA.add(iter-1,CurrentFoci);
							OAi.add(iter-1, CurrentFoci.FOindex);
						}
				}
			}
				//System.out.print(objnum);
				//System.out.print(" ");
				objnum++;
				if (objnum==frame.length){
					break;
				}
		}
			// Clear space
			s.empty();
			s = new space(delx,dely);
			// Make the new space
			FociObject[] toadd = toaddtospace.toArray(new FociObject[toaddtospace.size()]);
			for(int i=0; i<toadd.length; i++){
				int ii = toadd[i].ii;
				int jj = toadd[i].jj;
				s.addtospace(ii,jj,toadd[i]);
				counter++;
			}
			OA.resize(iter-1);
			OAi.resize(iter-1);
			}
		// Now return the ObjectArray
		System.out.print("\n\n");
		OA.print();
		System.out.print("counter = ");
		System.out.print(counter);
		//Writetoxml.writetoxml(OAi,OA);
		IJ.log("Tracking done!");
		//PlotData.plot(OAi, OA);
		PlotDataJoost.plot(OAi,OA, ColorSet, imp);  //edited out but dont know why feb 2016
		PlotData.plot(OAi, OA, Data.directory);
   //same
		}
	}
